"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Highlight = void 0;
var react_1 = __importStar(require("react"));
require("../style/Highlight.css");
var Highlight = /** @class */ (function (_super) {
    __extends(Highlight, _super);
    function Highlight() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Highlight.prototype.render = function () {
        var _a = this.props, position = _a.position, onClick = _a.onClick, onMouseOver = _a.onMouseOver, onMouseOut = _a.onMouseOut, comment = _a.comment, isScrolledTo = _a.isScrolledTo;
        var rects = position.rects;
        return (react_1.default.createElement("div", { className: "Highlight " + (isScrolledTo ? "Highlight--scrolledTo" : "") },
            react_1.default.createElement("div", { className: "Highlight__parts" }, rects.map(function (rect, index) {
                rect['background'] = comment.color;
                return (react_1.default.createElement("div", { onMouseOver: onMouseOver, onMouseOut: onMouseOut, onClick: onClick, key: index, style: rect, className: "Highlight__part" }));
            }))));
    };
    return Highlight;
}(react_1.Component));
exports.Highlight = Highlight;
exports.default = Highlight;
//# sourceMappingURL=Highlight.js.map