var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React, { Component } from "react";
import { Rnd } from "react-rnd";
import { getPageFromElement } from "../lib/pdfjs-dom";
import "../style/AreaHighlight.css";
var AreaHighlight = /** @class */ (function (_super) {
    __extends(AreaHighlight, _super);
    function AreaHighlight() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AreaHighlight.prototype.render = function () {
        var _a = this.props, highlight = _a.highlight, onChange = _a.onChange, isScrolledTo = _a.isScrolledTo, otherProps = __rest(_a, ["highlight", "onChange", "isScrolledTo"]);
        return (React.createElement("div", { className: "AreaHighlight " + (isScrolledTo ? "AreaHighlight--scrolledTo" : "") },
            React.createElement(Rnd, __assign({ className: "AreaHighlight__part", onDragStop: function (_, data) {
                    var boundingRect = __assign(__assign({}, highlight.position.boundingRect), { top: data.y, left: data.x });
                    onChange(boundingRect);
                }, onResizeStop: function (_mouseEvent, _direction, ref, _delta, position) {
                    var _a;
                    var boundingRect = {
                        top: position.y,
                        left: position.x,
                        width: ref.offsetWidth,
                        height: ref.offsetHeight,
                        pageNumber: ((_a = getPageFromElement(ref)) === null || _a === void 0 ? void 0 : _a.number) || -1,
                    };
                    onChange(boundingRect);
                }, position: {
                    x: highlight.position.boundingRect.left,
                    y: highlight.position.boundingRect.top,
                }, size: {
                    width: highlight.position.boundingRect.width,
                    height: highlight.position.boundingRect.height,
                }, onClick: function (event) {
                    event.stopPropagation();
                    event.preventDefault();
                } }, otherProps))));
    };
    return AreaHighlight;
}(Component));
export { AreaHighlight };
export default AreaHighlight;
//# sourceMappingURL=AreaHighlight.js.map