"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Tip = void 0;
var react_1 = __importStar(require("react"));
require("../style/Tip.css");
var randomcolor_1 = __importDefault(require("randomcolor"));
var Tip = /** @class */ (function (_super) {
    __extends(Tip, _super);
    function Tip() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            label: '',
            selectValue: '',
            color: ''
        };
        _this.handleChange = function (event) {
            var colorNew = (0, randomcolor_1.default)();
            var eLabel = event.target.options[event.target.selectedIndex].text;
            _this.setState({
                label: eLabel,
                selectValue: event.target.value,
                color: colorNew
            });
        };
        return _this;
    }
    Tip.prototype.render = function () {
        var _a = this.props, onConfirm = _a.onConfirm, highlight = _a.highlight, options = _a.options;
        var _b = this.state, selectValue = _b.selectValue, color = _b.color, label = _b.label;
        return (react_1.default.createElement("div", { className: "Tip" },
            react_1.default.createElement("form", { className: "Tip__card", onSubmit: function (event) {
                    event.preventDefault();
                    onConfirm({ selectValue: selectValue, color: color, label: label });
                } },
                react_1.default.createElement("h4", { style: { color: '#333' } }, "Please select the desired field."),
                react_1.default.createElement("div", null,
                    react_1.default.createElement("select", { defaultValue: highlight ? highlight.comment.selectValue : '', onChange: this.handleChange, style: {
                            width: '80%',
                            margin: 10,
                            padding: 8,
                        } }, options
                        && options.length > 0
                        && options.map(function (option, index) {
                            return (react_1.default.createElement("option", { style: {
                                    fontSize: 14,
                                    padding: 10,
                                }, key: index, value: option.value }, option.label));
                        }))),
                react_1.default.createElement("div", null,
                    react_1.default.createElement("input", { type: "submit", disabled: selectValue ? false : true, value: "Done", style: {
                            width: '100%',
                            backgroundColor: 'rgba(11, 161, 11, 0.753)'
                        } })))));
    };
    return Tip;
}(react_1.Component));
exports.Tip = Tip;
exports.default = Tip;
//# sourceMappingURL=Tip.js.map