var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import React, { Component } from "react";
import "../style/Highlight.css";
var Highlight = /** @class */ (function (_super) {
    __extends(Highlight, _super);
    function Highlight() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Highlight.prototype.render = function () {
        var _a = this.props, position = _a.position, onClick = _a.onClick, onMouseOver = _a.onMouseOver, onMouseOut = _a.onMouseOut, comment = _a.comment, isScrolledTo = _a.isScrolledTo;
        var rects = position.rects;
        return (React.createElement("div", { className: "Highlight " + (isScrolledTo ? "Highlight--scrolledTo" : "") },
            React.createElement("div", { className: "Highlight__parts" }, rects.map(function (rect, index) {
                rect['background'] = comment.color;
                return (React.createElement("div", { onMouseOver: onMouseOver, onMouseOut: onMouseOut, onClick: onClick, key: index, style: rect, className: "Highlight__part" }));
            }))));
    };
    return Highlight;
}(Component));
export { Highlight };
export default Highlight;
//# sourceMappingURL=Highlight.js.map