var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import React, { Component } from "react";
import "../style/Tip.css";
import RandomColor from 'randomcolor';
var Tip = /** @class */ (function (_super) {
    __extends(Tip, _super);
    function Tip() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            label: '',
            selectValue: '',
            color: ''
        };
        _this.handleChange = function (event) {
            var colorNew = RandomColor();
            var eLabel = event.target.options[event.target.selectedIndex].text;
            _this.setState({
                label: eLabel,
                selectValue: event.target.value,
                color: colorNew
            });
        };
        return _this;
    }
    Tip.prototype.render = function () {
        var _a = this.props, onConfirm = _a.onConfirm, highlight = _a.highlight, options = _a.options;
        var _b = this.state, selectValue = _b.selectValue, color = _b.color, label = _b.label;
        return (React.createElement("div", { className: "Tip" },
            React.createElement("form", { className: "Tip__card", onSubmit: function (event) {
                    event.preventDefault();
                    onConfirm({ selectValue: selectValue, color: color, label: label });
                } },
                React.createElement("h4", { style: { color: '#333' } }, "Please select the desired field."),
                React.createElement("div", null,
                    React.createElement("select", { defaultValue: highlight ? highlight.comment.selectValue : '', onChange: this.handleChange, style: {
                            width: '80%',
                            margin: 10,
                            padding: 8,
                        } }, options
                        && options.length > 0
                        && options.map(function (option, index) {
                            return (React.createElement("option", { style: {
                                    fontSize: 14,
                                    padding: 10,
                                }, key: index, value: option.value }, option.label));
                        }))),
                React.createElement("div", null,
                    React.createElement("input", { type: "submit", disabled: selectValue ? false : true, value: "Done", style: {
                            width: '100%',
                            backgroundColor: 'rgba(11, 161, 11, 0.753)'
                        } })))));
    };
    return Tip;
}(Component));
export { Tip };
export default Tip;
//# sourceMappingURL=Tip.js.map